include     Test.inc

@CopyString@8 PROTO SYSCALL         ; a trick to avoid the leading underscore
                                    ; in the object module

CopyString EQU <@CopyString@8>

fcallX MACRO func:REQ,param1,param2 ; macro to call FASTCALL functions
                                    ; taking maximum two parameters
    IFNB    <param2>
        mov     edx,param2
    ENDIF

    IFNB    <param1>
        mov     ecx,param1
    ENDIF
    
    call    func

ENDM

.data
src     db 'This is a test string.',0
message db 'Destination buffer = %s',13,10,0

.data?
dest    db 100 dup(?)

.code

start:

    fcallX  CopyString,OFFSET dest,OFFSET src
    invoke  crt_printf,ADDR message,ADDR dest
    invoke  ExitProcess,0

END start
